import moment from 'moment';
import { emojiName, emojiUrl, emojiMap } from './emojiMap.js';
const ua=navigator.userAgent;
export const assetsUrl="https://zhenyanapp-gen.oss-cn-qingdao.aliyuncs.com/wechat-mini-pro/";
//export const IMSDKCode=1400293452;
export const IMSDKCode=1400456480;
//const apiHost = 'http://192.168.1.253:8080' //本地; 
//const apiHost = 'https://mini.sugarpark.cn'
export const apiHost = 'http://jliao-api2-svc-test.internal.jiebide.xin'
export const protocal={
	behaviorStandar:'https://h5.sugarpark.cn/agreement/behavior-standard.html',
	userAgreement:'https://h5.sugarpark.cn/agreement/user-agreement.html',
	privacy:'https://h5.sugarpark.cn/agreement/privacy.html',
	addedService:'https://h5.sugarpark.cn/agreement/added-service.html'
}
export const base64toBlob=(dataurl)=>{
	var arr = dataurl.split(','), mime = arr[0].match(/:(.*?);/)[1],
		bstr = atob(arr[1]), n = bstr.length, u8arr = new Uint8Array(n);
	while (n--) {
		u8arr[n] = bstr.charCodeAt(n);
	}
	return new Blob([u8arr], { type: mime });
}
export const blobToFile=(theBlob, fileName)=>{
       theBlob.lastModifiedDate = new Date();
       theBlob.name = fileName;
       return theBlob;
}
export const getApiHost=()=>{
	return apiHost;
}
export const fileToBase64=(file)=>{
	return new Promise((resolve, reject) => {
	    let reader = new FileReader();
	    reader.readAsDataURL(file);
	    reader.onload = (e) => {
	      resolve(e.target.result);
	    };
	  });
}
// 解析小程序text, 表情信息也是[嘻嘻]文本

export const parseText=(message)=>{
  const renderDom = [];
  let temp = message.payload.text;
  let left = -1;
  let right = -1;

  while (temp !== '') {
    left = temp.indexOf('[');
    right = temp.indexOf(']');

    switch (left) {
      case 0:
        if (right === -1) {
          renderDom.push({
            name: 'span',
            text: temp
          });
          temp = '';
        } else {
          const _emoji = temp.slice(0, right + 1);

          if (emojiMap[_emoji]) {
            renderDom.push({
              name: 'img',
              src: emojiUrl + emojiMap[_emoji]
            });
            temp = temp.substring(right + 1);
          } else {
            renderDom.push({
              name: 'span',
              text: '['
            });
            temp = temp.slice(1);
          }
        }

        break;

      case -1:
        renderDom.push({
          name: 'span',
          text: temp
        });
        temp = '';
        break;

      default:
        renderDom.push({
          name: 'span',
          text: temp.slice(0, left)
        });
        temp = temp.substring(left);
        break;
    }
  }

  return renderDom;
}
// 解析图片消息
export const parseImage=(message)=>{
  const renderDom = [{
    name: 'image',
    // 这里默认渲染的是 1080P 的图片
    src: message.payload.imageInfoArray[0].url
  }];
  return renderDom;
} 
// 解析视频消息
export const parseVideo=(message)=>{
  const renderDom = {
    name: 'video',
    src: message.payload.videoUrl
  };
  return renderDom;
} 
// 解析语音消息
export const parseAudio=(message)=>{
  const renderDom = {
    name: 'audio',
    src: message.payload.url,
    second: message.payload.second === 0 ? 1 : message.payload.second
  };
  return renderDom;
}
export const hasSafeArea = () => {
	let sWidth = window.innerWidth * window.devicePixelRatio,
		sHeight = window.innerHeight * window.devicePixelRatio;
		console.log(sWidth,sHeight)
	if (sWidth == 1125 && sHeight == 2436) {
		return true;
	} else if (sWidth == 828 && sHeight == 1792) {
		return true;
	} else if (sWidth == 1170 && sHeight == 2532) {
		return true;
	} else if (sWidth == 1242 && sHeight == 2688) {
		return true;
	} else if (sWidth == 1284 && sHeight == 2778) {
		return true;
	}
	return false

}
export const timeFn = (dateBeginTime, dateEndTime) => {
	var timeFn;
	var dateDiff = dateEndTime - dateBeginTime; //时间差的毫秒数
	var dayDiff = Math.floor(dateDiff / (24 * 3600 * 1000)); //计算出相差天数
	var leave1 = dateDiff % (24 * 3600 * 1000) //计算天数后剩余的毫秒数
	var hours = Math.floor(leave1 / (3600 * 1000)) //计算出小时数
	//计算相差分钟数
	var leave2 = leave1 % (3600 * 1000) //计算小时数后剩余的毫秒数
	var minutes = Math.floor(leave2 / (60 * 1000)) //计算相差分钟数
	//计算相差秒数
	var leave3 = leave2 % (60 * 1000) //计算分钟数后剩余的毫秒数
	var seconds = Math.round(leave3 / 1000)
	var timeFn = dayDiff + "天" + hours + "小时" + minutes + "分钟" + seconds + "秒";
	return timeFn;
}
export const checkPhone = (phone) => { //手机号码
	let reg = /^(13[0-9]|14[01456879]|15[0-35-9]|16[2567]|17[0-8]|18[0-9]|19[0-35-9])\d{8}$/;
	if(phone.substr(0,3)==='120'&&phone.length===11){
		  return true;
	}
	if (reg.test(phone)) {
	  return true;
	} else {
	  return false;
	}
}
export const checkTel = (tel) => { //座机号码不支持分机
	return /0\d{2,3}-\d{7,8}/.test(tel)
}
export const checkIdNo = (idNo) => {
	return /(^\d{15}$)|(^\d{18}$)|(^\d{17}(\d|X|x)$)/.test(idNo)
}
export const checkChinese = (str) => {
	return /^[\u4e00-\u9fa5]+$/.test(str)
}
export const compare = (property) => {
	return (a, b) => {
		var value1 = a[property];
		var value2 = b[property];
		return value1 - value2;
	}
}
/**
 * 访问终端类型
 */
export const getSrcTypeS = () => {
    let srcType = 2;
    let ua = navigator.userAgent.toLowerCase();

    if (ua.match(/MicroMessenger/i) == "micromessenger") {
        srcType = 1
    } else if (ua.indexOf(' qq') > -1 && ua.indexOf('mqqbrowser') < 0) {
        srcType = 0
    }

    return srcType;
}
export function getIPaddress(){
	return new Promise((resolve,reject)=>{
		$.get("https://api.ipify.org/?format=json",function(data){
			let ip=data.ip;
			resolve(ip)
		})
	})
	
}
export function getAddress(ip){
	return new Promise((resolve,reject)=>{
		$.get(`https://restapi.amap.com/v3/ip?ip=${ip}&output=json&key=842a0a6f5b3966a8c77fb1ee88f1feca`,function(data){
			resolve(data)
		})
	})
}
export function getDetailAddress(str){
	return new Promise((resolve,reject)=>{
		$.get(`https://restapi.amap.com/v3/geocode/regeo?location=${str}&output=json&key=842a0a6f5b3966a8c77fb1ee88f1feca`,function(data){
			resolve(data)
		})
	})
	
}
export function deviceSystem(){
    let flag = '';
    let bIsIpad = ua.toLowerCase().match(/ipad/i) == "ipad";
    let bIsIphoneOs = ua.toLowerCase().match(/iphone os/i) == "iphone os";
    let bIsMidp = ua.toLowerCase().match(/midp/i) == "midp";
    let bIsUc7 = ua.toLowerCase().match(/rv:1.2.3.4/i) == "rv:1.2.3.4";
    let bIsUc = ua.toLowerCase().match(/ucweb/i) == "ucweb";
    let bIsAndroid = ua.toLowerCase().match(/android/i) == "android";
    let bIsCE = ua.toLowerCase().match(/windows ce/i) == "windows ce";
    let bIsWM = ua.toLowerCase().match(/windows mobile/i) == "windows mobile";

    if (bIsIpad || bIsIphoneOs || bIsMidp || bIsUc7 || bIsUc || bIsAndroid || bIsCE || bIsWM) {
        // 移动设备
        if (bIsAndroid) {
            flag = 1;
        } else if (bIsIpad || bIsIphoneOs) {
            flag = 2;
        }
    } else {
        // pc设备
        flag = '';
    }
    return flag;
}
//将base64转换为文件
export function dataURLtoFile(base64) {
    var arr = base64.split(','),
        bstr = atob(arr[1]),
        n = bstr.length,
        u8arr = new Uint8Array(n);
    while (n--) {
        u8arr[n] = bstr.charCodeAt(n)
    }
    return new File([u8arr], file.name, {
        type: file.type
    })
}
export function getPlatform() {
  var u = navigator.userAgent;
  var isAndroid = u.indexOf("Android") > -1 || u.indexOf("Adr") > -1; //android终端
  var isiOS = !!u.match(/\(i[^;]+;( U;)? CPU.+Mac OS X/); //ios终端
  let flag = "";
  if (isAndroid) {
    flag = "android";
  } else if (isiOS) {
    flag = "ios";
  } else {
    flag = "other";
  }
  // alert(flag)
  return flag;
}

// 判断设备
export function isWX() {
  var ua = navigator.userAgent.toLowerCase();//获取判断用的对象
  let isWX = false
  if (ua.match(/MicroMessenger/i) == "micromessenger") {
    //在微信中打开
    isWX = true
  }
  // alert(flag)
  return isWX;
}

// 分享
export function appShare() {
  // console.log(111)
  // console.log(getPlatform())
  switch (getPlatform()) {
    case "ios":
      window.webkit.messageHandlers.ReactNativeWebView.postMessage({
        action: "share",
      });
      break;
    case "android":
      AndroidZhenYan.callAndroid(JSON.stringify({ type: 2 })); // 分享
      break;
    default:
      break;
  }
}

// 设置localstorage
export function setExpire(key, value, expire) {
  let obj = {
    data: value,
    time: Date.now(),
    expire: expire,
  };
  localStorage.setItem(key, JSON.stringify(obj));
}
// 获取localstorage
export function getExpire(key) {
  let val = localStorage.getItem(key);
  if (!val) {
    return null;
  }
  val = JSON.parse(val);
  if (Date.now() - val.time > val.expire) {
    localStorage.removeItem(key);
    return null;
  }
  return val.data;
}

/**
 * @param {string} mobile
 * @returns {Object}
 */
export function isMobile(val) {
  let reg = /^(13[0-9]|14[01456879]|15[0-35-9]|16[2567]|17[0-8]|18[0-9]|19[0-35-9])\d{8}$/;
  if(val.substr(0,3)==='120'&&val.length===11){
	  return true;
  }
  if (reg.test(val)) {
    return true;
  } else {
    return false;
  }
}

export function getDateFromat(time,fmt) {
  var date=new Date(time);
  var year=date.getFullYear();
  var month= date.getMonth()+1<10 ? "0"+(date.getMonth()+1) : date.getMonth()+1;
  var day=date.getDate()<10 ? "0"+date.getDate() : date.getDate();
  var hours=date.getHours()<10 ? "0"+date.getHours() : date.getHours();
  var minutes=date.getMinutes()<10 ? "0"+date.getMinutes() : date.getMinutes();
  var seconds=date.getSeconds()<10 ? "0"+date.getSeconds() : date.getSeconds();
  // 拼接
  if (fmt == 'yyyy.MM.dd') {
    return year+"."+month+"."+day;
  } else {
    return year+"-"+month+"-"+day+" "+hours+":"+minutes+":"+seconds;
  }
}

// 获取数组Keys
export function getArrayKeys(arr, key) {
  if (!arr) return [];
  if (!key) {
    key = "label";
  }
  let reArr = [];
  for (let i = 0; i < arr.length; i++) {
    reArr.push(arr[i][key]);
  }
  return reArr;
}

// 修改数组key
export function updateArrayKeys(arr) {
  if (!arr) return [];
  let reArr = [];
  arr.map((item) => {
    reArr.push({
      name: item.label,
      value: item.value,
    });
  });
  return reArr;
}

// 获取雷达图指示点
export function getDarArrayKeys(arr) {
  if (!arr) return [];
  let reArr = [];
  arr.map((item) => {
    reArr.push({
      name: item.label,
    });
  });
  return reArr;
}

// 获取嵌套数组data
export function getArrayDatas(arr, label) {
  if (!arr) return [];
  let reArr = [];

  arr.map((item) => {
    if (!item.datas) item.datas = [];
    item.datas.map((data) => {
      if (data.label === label) {
        reArr.push(data.value);
      }
    });
  });
  return reArr;
}

// 获取嵌套数组data
export function getArrayDatasRes(arr, label) {
  if (!arr) return [];
  let reArr = [];

  arr.map((item) => {
    if (item.name === label) {
      item.datas.map((data) => {
        reArr.push(data.value);
      });
    }
  });
  return reArr;
}

// 获取数组并删除无用data
export function getObjDatas(arr, label) {
  if (!arr) return [];
  let reArr = [];
  arr.map((item) => {
    if (item.label === label) {
      for (let key in item) {
        if (key !== "label") {
          reArr.push(item[key]);
        }
      }
    }
  });
  // console.log(reArr)
  return reArr;
}

export function formatTime(date, fmt) {
  var o = {
    "M+": date.getMonth() + 1, //月份
    "d+": date.getDate(), //日
    "h+": date.getHours(), //小时
    "m+": date.getMinutes(), //分
    "s+": date.getSeconds(), //秒
    "q+": Math.floor((date.getMonth() + 3) / 3), //季度
    S: date.getMilliseconds(), //毫秒
  };
  if (/(y+)/.test(fmt))
    fmt = fmt.replace(
      RegExp.$1,
      (date.getFullYear() + "").substr(4 - RegExp.$1.length)
    );
  for (var k in o)
    if (new RegExp("(" + k + ")").test(fmt))
      fmt = fmt.replace(
        RegExp.$1,
        RegExp.$1.length == 1 ? o[k] : ("00" + o[k]).substr(("" + o[k]).length)
      );
  return fmt;
}
export function isIphoneX(){
	if(getPlatform()!=='ios'){
		return false;
	}
	// if(window.screen.width==375&&window.screen.height==724){return true;}//iphoneX/12/13 mini 
	// else if(window.screen.width==414&&window.screen.height==869){return true;}//iphoneXR/11/iphoneXS max
	// else if(window.screen.width==390&&window.screen.height==753){return true;}//iphone12/13(pro)
	// else if(window.screen.width==428&&window.screen.height==835){return true;}//iphone12/13 pro max
	return true;
}
export function isSafari(){
	if(/Safari/.test(navigator.userAgent) && !/Chrome/.test(navigator.userAgent) && !/qqbrowse/.test(navigator.userAgent.toLocaleLowerCase())){
		return true;
	}
	return false;
}
export function toDecimal2(x) {    
	var f = parseFloat(x);    
	if (isNaN(f)) {    
		return false;    
	}    
	var f = Math.round(x*100)/10000;    
	var s = f.toString();    
	var rs = s.indexOf('.');    
	if (rs < 0) {    
		rs = s.length;    
		s += '.';    
	}    
	while (s.length <= rs + 2) {    
		s += '0';    
	}    
	return s;    
}