import axios from "axios";
import Vue from "vue";
import router from "../router";
import Vant from 'vant';
import 'vant/lib/index.css';
Vue.use(Vant);
import $ from "jquery";
import {deviceSystem,getSrcTypeS} from './index.js';
const otherHost='http://jliao-h5-web-test.internal.jiebide.xin';//H5地址
//const otherHost='http://192.168.1.253:17031'
const ua=navigator.userAgent;
var that=this;
// 环境的切换
let domain =  document.domain;
if (domain  === 'jliao-h5-promote-test.internal.jiebide.xin'){
    axios.defaults.baseURL = "http://jliao-api2-svc-test.internal.jiebide.xin";
} else if (domain  === 'h5.yourongdai.cn') {
    axios.defaults.baseURL = "https://h5.api.yourongdai.cn";
} else if (domain  === 'huirong.bicredit.xin' || domain==='h.bicredit.xin') {
    axios.defaults.baseURL = "https://api.promote.bicredit.xin";
} else{
	axios.defaults.baseURL = "http://jliao-api2-svc-test.internal.jiebide.xin";
}
// 请求超时时间
axios.defaults.timeout = 300000;

// post请求头
axios.defaults.headers.post["Content-Type"] = "application/json";

// 请求开始时，开启加载中动画，出错了提示并关闭动画
axios.interceptors.request.use(
  (config) => {
	let LL_Ukn =localStorage.getItem('LL_Ukn')||"szxe/TwE/wNJxcF+51069Dw3KHJQmbEuE2tEVHG4ETQ1TEnZ6loF7MQdmCFePTWTS9NE8zhDBrvPplTUYNnlPa10jJ1GycLQjpe2CkO+UvflA8adpe/uD5z2C8Bp1Pg9cThzHmqxeAe1Oq9G1eo3PKfGGYLALGx+dgFPYMn06M/Y+lVio4WpXbNW8KMNkWyxnFZnpZEXzzyDUCT13TMF9tevVJ9/Sb3yBgLiLYnydplax+zjkFqwGSiDrQWR/E8s";
	let LL_Csi={
		av:"2.6.0",
		brand:"Apple",
		currTime:1654149186191,
		deviceCode:'',
		iOS:{"idfa":"00000000-0000-0000-0000-000000000000"},
		lang:"zh","model":"iPhone12,5","ov":"15.3.1",
		pkgCate:"JyPark",
		platform:"WechatMP",
		resolution:{"h":2688,"s":3,"w":1242},
		appId:15,
		android:{market:'Unknown'},
		heartBeatParam:{
			city:encodeURIComponent(localStorage.getItem('city')),
			geo:{
				lat:String(localStorage.getItem('latitude')),
				lon:String(localStorage.getItem('longitude'))
			}
		}
	};
	let token= localStorage.getItem('token')||"88b99b11d3fc4cc3a71959b824678ce8";
	config.headers["LL_Ukn"] = LL_Ukn;
	config.headers["LL_Csi"] = JSON.stringify(LL_Csi);
	config.headers["token"] = token;

    return config;
  },
  (error) => {
    return Promise.reject(error);
  }
);

// 请求完成时，关闭加载中动画，返回数据或错误信息
axios.interceptors.response.use(
  (response) => {
    // 一切正常，返回数据或空对象
	if(response.data.status==="Unauthorized"){
		
		router.replace({name:'login'});
		setTimeout(()=>{
			Vue.prototype.$toast('登录失效，请重新登录');
		},1000)
		
		return;
	}
	return response.data;
  },
  (error) => {
    return Promise.reject(error);
  }
);

/**
 * get方法，对应get请求
 * @param {String} url [请求的url地址]
 * @param {Object} params [请求时携带的参数]
 */
export function get(url, params) {
  if (params) {
    params.token = sessionStorage.token;
  } else {
    params = {
      token: sessionStorage.token,
    };
  }
  for (let key in params) {
    if (!params[key]) {
      delete params[key];
    }
  }
  return new Promise((resolve, reject) => {
    axios
      .get(url, {
        params: params,
      })
      .then((res) => {
        resolve(res);
      })
      .catch((err) => {
        reject(err);
      });
  });
}

/**
 * put方法，对应put请求
 * @param {String} url [请求的url地址]
 * @param {Object} params [请求时携带的参数]
 */
export function put(url, params) {
  return new Promise((resolve, reject) => {
    axios
      .put(url, params)
      .then((res) => {
        resolve(res);
      })
      .catch((err) => {
        reject(err);
      });
  });
}

/**
 * delete方法，对应delete请求
 * @param {String} url [请求的url地址]
 * @param {Object} params [请求时携带的参数]
 */
export function del(url) {
  return new Promise((resolve, reject) => {
    axios
      .delete(url)
      .then((res) => {
        // MintUI.Indicator.close()
        resolve(res);
      })
      .catch((err) => {
        // MintUI.Indicator.close()
        // if(url.indexOf('/paragraph/')<0){
        reject(err);
        // }
      });
  });
}

/**
 * post方法，对应post请求
 * @param {String} url [请求的url地址]
 * @param {Object} params [请求时携带的参数]
 */
export function post(url,methods, params) {
  return new Promise((resolve, reject) => {
    axios
      .post(url, params)
      .then((res) => {
        resolve(res);
      })
      .catch((err) => {
        reject(err);
      });
  });
}

/**
 * jquery post方法，对应post请求用于调用第三方接口
 * @param {String} url [请求的url地址]
 * @param {Object} params [请求时携带的参数]
 */
export function ajaxPost(url,type,params){
	return new Promise((resolve,reject)=>{
		$.ajax({
			type:type,
			url:`${otherHost}${url}`,
			data: JSON.stringify(params),
			dataType: "json",
			contentType: "application/json",
			// 设置头部属性
			beforeSend: function(request) {
				request.setRequestHeader("LL_Ukn", "Ti26M9wy2y5xl5OCtc6Ohyy79b7pe9ikMqRZM3CwhpPJSMYnumUAYHNvqC1i5p2lTCkLkz9/v+rjNfM2hLjccQXxd7a6+zk6yyS4lSEXowzbL4jT/ETEi3bsrH7yPRAvEI8E0YTIMeCjwz0liuHXOw==");
			},
			success: function (data) {
				  if(data.status==='Succ'){
					  resolve(data.data);
				  }
				  else{
					  reject(data.msg)
				  }
			}
		})
	})
}